// Image class header
#pragma once

#include "GraphicsResource.h"
#include "VideoMemoryAllocator.h"

namespace nf::client::render {
    class Image : GraphicsResource {
    public:
        Image(const VkDevice& device, VideoMemoryAllocator& allocator, const VkCommandPool& commandPool, const VkQueue& queue, const std::string& data);

        const VkImageView& getView() const;

        ~Image();
    private:
        VideoMemoryAllocator& m_allocator;

        VkImage m_handle;
        VideoMemoryAllocation m_allocation;
        VkImageView m_view;
    };
}
